searchNodes=[{"ref":"Entrance.html","title":"Entrance","type":"module","doc":"Provides authentication helpers that take advantage of the options configured in your config files."},{"ref":"Entrance.html#auth/3","title":"Entrance.auth/3","type":"function","doc":"Authenticates an user by the default authenticable field (defined in your configurations) and password. Returns the user if the user is found and the password is correct, otherwise nil. For example, if the default authenticable field configured is :email, it will try match with the :email field of user schema. Requires user_module, security_module, repo and default_authenticable_field to be configured via Mix.Config. Entrance.auth(&quot;joe@dirt.com&quot;, &quot;brandyr00lz&quot;) If you want to authenticate other modules, you can pass in the module directly. Entrance.auth(Customer, &quot;brandy@dirt.com&quot;, &quot;super-password&quot;)"},{"ref":"Entrance.html#auth_by/3","title":"Entrance.auth_by/3","type":"function","doc":"Authenticates an user by checking more than one field. Returns the user if the user is found and the password is correct, otherwise nil. Requires user_module, security_module, and repo to be configured via Mix.Config. Entrance.auth_by([email: &quot;joe@dirt.com&quot;, admin: true], &quot;brandyr00lz&quot;) If you want to authenticate other modules, you can pass in the module directly. Entrance.auth_by(Customer, [nickname: &quot;truehenrique&quot;, admin: true], &quot;super-password&quot;)"},{"ref":"Entrance.html#auth_one/4","title":"Entrance.auth_one/4","type":"function","doc":"Receives an atom list as fields list, a value and a password. Authenticates a user by at least one field in the fields list. Returns the user if the user is found and the password is correct, otherwise nil. Requires user_module, security_module, and repo to be configured via Mix.Config. Entrance.auth_one([:email, :nickname], &quot;my-nickname&quot;, &quot;my-password&quot;) If you want to authenticate other modules, you can pass in the module directly. Entrance.auth_one(Customer, [:nickname, :email], &quot;my@email.com&quot;, &quot;my-password&quot;)"},{"ref":"Entrance.html#auth_one_by/4","title":"Entrance.auth_one_by/4","type":"function","doc":"Receives a tuple with an atom list and a value, a keyword list and a password. First verify if there is a user with one of the atom list fields matching the value. If the user is found, verify if the user schema fields match with the keyword list values. If a user is found, the fields match, and the password is correct, returns the user, otherwise nil. Requires user_module, security_module, and repo to be configured via Mix.Config. Entrance.auth_one_by({[:email, :nickname], &quot;value&quot;}, [admin: true] , &quot;my-password&quot;) If you want to authenticate other modules, you can pass in the module directly. Entrance.auth_one_by(Customer, {[:email, :nickname], &quot;value&quot;}, [admin: true], &quot;my-password&quot;)"},{"ref":"Entrance.html#auth_user/2","title":"Entrance.auth_user/2","type":"function","doc":"Authenticates a user. Returns true if the user&#39;s password and the given password match based on the security_module strategy configured, otherwise false. Requires user_module, security_module, and repo to be configured via Mix.Config. user = Myapp.Repo.get(Myapp.User, 1) Entrance.auth_user(user, &quot;brandyr00lz&quot;)"},{"ref":"Entrance.html#logged_in?/1","title":"Entrance.logged_in?/1","type":"function","doc":"Returns true if passed in conns assigns has a non-nil :current_user, otherwise returns false. Make sure your pipeline uses a login plug to fetch the current user for this function to work correctly.. user = Myapp.Repo.get(Myapp.User, 1) Entrance.auth_user(user, &quot;brandyr00lz&quot;)"},{"ref":"Entrance.Auth.Bcrypt.html","title":"Entrance.Auth.Bcrypt","type":"module","doc":"Provides functions for hashing passwords and authenticating users using Bcrypt. This module assumes that you have a virtual field named password, and a database backed string field named hashed_password. Usage Example defmodule YourApp.Accounts.User do use Ecto.Schema import Ecto.Changeset import Entrance.Auth.Bcrypt, only: [hash_password: 1] # ... schema &quot;users&quot; do field :email, :string field :password, :string, virtual: true field :hashed_password, :string field :session_secret, :string timestamps() end def create_changeset(user, attrs) do user |&gt; cast(attrs, [:email, :password, :hashed_password, :session_secret]) |&gt; validate_required([:email, :password]) |&gt; hash_password # ... end end To authenticate a user in your application, you can use auth/2: user = Repo.get(User, 1) password = &quot;user@password&quot; Entrance.Auth.Bcrypt.auth(user, password)"},{"ref":"Entrance.Auth.Bcrypt.html#auth/2","title":"Entrance.Auth.Bcrypt.auth/2","type":"function","doc":"Compares the given password against the given user&#39;s password. user = %{hashed_password: &quot;iHkKDjU_example&quot;} password = &quot;user@password&quot; Entrance.Auth.Bcrypt.auth(user, password)"},{"ref":"Entrance.Auth.Bcrypt.html#hash_password/1","title":"Entrance.Auth.Bcrypt.hash_password/1","type":"function","doc":"Takes a changeset and turns the virtual password field into a hashed_password change on the changeset. import Entrance.Auth.Bcrypt, only: [hash_password: 1] # ... your user schema def create_changeset(user, attrs) do user |&gt; cast(attrs, [:email, :password, :hashed_password, :session_secret]) |&gt; validate_required([:email, :password]) |&gt; hash_password # :) end"},{"ref":"Entrance.Auth.Bcrypt.html#no_user_verify/0","title":"Entrance.Auth.Bcrypt.no_user_verify/0","type":"function","doc":"Simulates password check to help prevent timing attacks. Delegates to Bcrypt.no_user_verify/0."},{"ref":"Entrance.Auth.Secret.html","title":"Entrance.Auth.Secret","type":"module","doc":"Provides functions for creating secure random strings to be used as session secret. This module assumes that you have a field session_secret in your db table. Usage Example defmodule YourAppWeb.UserController do use YourAppWeb, :controller alias YourApp.Repo alias Entrance.Auth.Secret alias YourApp.Accounts.User def create(conn, %{&quot;user&quot; =&gt; user_params}) do changeset = %User{} |&gt; User.create_changeset(user_params) |&gt; Secret.put_session_secret() case Repo.insert(changeset) do {:ok, _user} -&gt; conn |&gt; redirect(to: &quot;/&quot;) {:error, changeset} -&gt; conn |&gt; render(&quot;new.html&quot;, changeset: changeset) end end end Setting the session key for an user is only needed on creation or if a user session did get compromised."},{"ref":"Entrance.Auth.Secret.html#put_session_secret/2","title":"Entrance.Auth.Secret.put_session_secret/2","type":"function","doc":"Takes a changeset and adds a secure random string in the session_secret field. %User{} |&gt; User.create_changeset(user_params) |&gt; Secret.put_session_secret()"},{"ref":"Entrance.Login.html","title":"Entrance.Login","type":"behaviour","doc":"This module provides boilerplate for creating Plugs for authentication with Entrance. Modules that use Entrance.Login should implement a get_current_user/1 function that accepts a connection and returns either the current user, or nil. Those modules should also implement helper functions such as login, logout, and etc. when applicable. Example defmodule YourApp.Auth do use Entrance.Login defp get_current_user(conn) do YourApp.Repo.get(YourApp.Accounts.User, 1) end end Under the hood Entrance.Login implements the callbacks for the Plug behaviour. Both init/1 and call/2 are overridable."},{"ref":"Entrance.Login.html#c:get_current_user/1","title":"Entrance.Login.get_current_user/1","type":"callback","doc":"Returns either the current user or nil based on the state of the passed in conn."},{"ref":"Entrance.Login.Session.html","title":"Entrance.Login.Session","type":"module","doc":""},{"ref":"Entrance.Login.Session.html#get_current_user/1","title":"Entrance.Login.Session.get_current_user/1","type":"function","doc":"Returns the current user or nil based on :user_id in the session. import Entrance.Login.Session # ... your controller login(conn, Repo.get(User, 1)) user = get_current_user(conn)"},{"ref":"Entrance.Login.Session.html#login/2","title":"Entrance.Login.Session.login/2","type":"function","doc":"Logs in given user by setting :user_id on the session of passed in conn. The user struct must have an :session_secret field. import Entrance.Login.Session # ... your controller user = Repo.get(User, 1) conn |&gt; login(user) |&gt; put_flash(:notice, &quot;Successfully logged in&quot;) |&gt; redirect(to: &quot;/&quot;)"},{"ref":"Entrance.Login.Session.html#logout/1","title":"Entrance.Login.Session.logout/1","type":"function","doc":"Logs out current user. import Entrance.Login.Session # ... your controller conn |&gt; logout |&gt; put_flash(:notice, &quot;Successfully logged out&quot;) |&gt; redirect(to: &quot;/&quot;)"},{"ref":"Entrance.User.html","title":"Entrance.User","type":"module","doc":"This module provider helpers functions for your app users management"},{"ref":"Entrance.User.html#create/2","title":"Entrance.User.create/2","type":"function","doc":"Execute this behind the scenes: alias Entrance.Auth.Secret # ... %YourUser{} |&gt; YourUser.create_changeset(user_params) |&gt; Secret.put_session_secret() |&gt; YourRepo.insert() Returns {:ok, user} or {:error, changeset} Requires user_module and repo to be configured via Mix.Config. Examples {:ok, user} = Entrance.User.create(%{&quot;email =&gt; &quot;joe@dirt.com&quot;, &quot;password&quot; =&gt; &quot;brandyr00lz&quot;}) If you want to use create/2 with other user schema, you can set the module directly. {:ok, customer} = Entrance.User.create(Customer, %{&quot;email =&gt; &quot;joe@dirt.com&quot;, &quot;password&quot; =&gt; &quot;brandyr00lz&quot;})"},{"ref":"Entrance.User.html#create!/2","title":"Entrance.User.create!/2","type":"function","doc":"Similar to Entrance.User.create/2, but returns the user struct and raises an error if user_params is invalid. Execute this behind the scenes: alias Entrance.Auth.Secret # ... %YourUser{} |&gt; YourUser.create_changeset(user_params) |&gt; Secret.put_session_secret() |&gt; YourRepo.insert!() Requires user_module and repo to be configured via Mix.Config. Examples user = Entrance.User.create!(%{&quot;email =&gt; &quot;joe@dirt.com&quot;, &quot;password&quot; =&gt; &quot;brandyr00lz&quot;}) If you want to use create!/2 with other user schema, you can set the module directly. customer = Entrance.User.create!(Customer, %{&quot;email =&gt; &quot;joe@dirt.com&quot;, &quot;password&quot; =&gt; &quot;brandyr00lz&quot;})"},{"ref":"Entrance.User.html#create_changeset/0","title":"Entrance.User.create_changeset/0","type":"function","doc":"Execute this behind the scenes: YourUser.create_changeset(%YourUser{}, %{}) Returns an Ecto.Changeset struct Requires user_module to be configured via Mix.Config. Example # YourAppWeb.UserController ... def new(conn, _params) do conn |&gt; render(&quot;new.html&quot;, changeset: Entrance.User.create_changeset) end"},{"ref":"Entrance.User.html#create_changeset/1","title":"Entrance.User.create_changeset/1","type":"function","doc":"Similar to Entrance.User.create_changeset/0 but not need the user_module to be configured via Mix.Config Example # YourAppWeb.UserController ... def new(conn, _params) do conn |&gt; render(&quot;new.html&quot;, changeset: Entrance.User.create_changeset(Customer)) end"},{"ref":"Mix.Tasks.Entrance.Gen.PhxModules.html","title":"Mix.Tasks.Entrance.Gen.PhxModules","type":"task","doc":"Creates phoenix modules for authentication with entrance (session_controller, user_controller and plugs/require_login). mix entrance.gen.phx_modules This generator will add the following files to lib/: * a controller in `lib/your_app_web/controllers/user_controller.ex` * a view in `lib/your_app_web/views/user_view.ex` * a controller in `lib/your_app_web/controllers/session_controller.ex` * a view in `lib/your_app_web/views/session_view.ex` * a plug in `lib/your_app_web/plugs/require_login.ex` And also a test file for each of this files. you can also set the modules context mix entrance.gen.phx_modules --context Accounts With &quot;--context Accounts&quot; creates: * a controller in `lib/your_app_web/controllers/accounts/user_controller.ex` * a view in `lib/your_app_web/views/accounts/user_view.ex` * a controller in `lib/your_app_web/controllers/accounts/session_controller.ex` * a view in `lib/your_app_web/views/accounts/session_view.ex` * a plug in `lib/your_app_web/plugs/accounts/require_login.ex`"},{"ref":"Mix.Tasks.Entrance.Gen.PhxRequireLogin.html","title":"Mix.Tasks.Entrance.Gen.PhxRequireLogin","type":"task","doc":"Creates phoenix require login plug for authentication with entrance"},{"ref":"Mix.Tasks.Entrance.Gen.PhxSessionController.html","title":"Mix.Tasks.Entrance.Gen.PhxSessionController","type":"task","doc":"Creates phoenix session controller for authentication with entrance"},{"ref":"Mix.Tasks.Entrance.Gen.PhxUserController.html","title":"Mix.Tasks.Entrance.Gen.PhxUserController","type":"task","doc":"Creates phoenix user controller for authentication with entrance"},{"ref":"readme.html","title":"Entrance","type":"extras","doc":"Entrance Modules and functions to make authentication with Plug / Phoenix and Ecto easy without tons of configuration or boxing users into rigid framework. The primary goal of Entrance is to build an opinionated interface and easy to use API on top of flexible modules that can also be used directly. If you like simple and beautiful code, you&#39;d like Entrance. You can find more in-depth documentation here."},{"ref":"readme.html#table-of-contents","title":"Entrance - Table of contents","type":"extras","doc":"Installation Phoenix Creating users Logging in users Requiring Authentication Logging out users Testing Mix tasks Contribute Credits Installation Add entrance to your dependencies in mix.exs. def deps do [{:entrance, &quot;~&gt; 0.4.1&quot;}] end Then add the configuration to your_app/config/config.exs config :entrance, repo: YourApp.Repo, security_module: Entrance.Auth.Bcrypt, user_module: YourApp.Accounts.User, default_authenticable_field: :email Phoenix First, generate a user schema with a hashed_password:string and session_secret:string field: $ mix phx.gen.schema Accounts.User users email:string hashed_password:string session_secret:string Run the migrations: $ mix ecto.migrate Next, use Entrance.Auth.Bcrypt in your new User module and add a virtual :password field. hash_password/1 is used in the changeset to hash our password and put it into the changeset as :hashed_password. your_app/lib/your_app/accounts/user.ex defmodule YourApp.Accounts.User do use Ecto.Schema import Ecto.Changeset import Entrance.Auth.Bcrypt, only: [hash_password: 1] schema &quot;users&quot; do field :email, :string field :password, :string, virtual: true # Add this line field :hashed_password, :string field :session_secret, :string timestamps() end def create_changeset(user, attrs) do # Define a create_changeset function user |&gt; cast(attrs, [:email, :password, :hashed_password, :session_secret]) # Dont forget to add :password here |&gt; validate_required([:email, :password]) # And here |&gt; hash_password # Add this line end end Finally, we can add our plug so we can have access to current_user on conn.assigns[:current_user]. 99% of the time that means adding the Entrance.Login.Session plug to your :browser pipeline: your_app/lib/your_app_web/router.ex pipeline :browser do # ... plug Entrance.Login.Session end Creating Users To create a user we can use the User.create_changeset/2 function we defined. Here we&#39;ll also add the session_secret to the user, which is only needed when creating an user or in case of compromised sessions. Example: defmodule YourAppWeb.UserController do use YourAppWeb, :controller alias YourApp.Repo alias Entrance.Auth.Secret alias YourApp.Accounts.User def new(conn, _params) do changeset = User.create_changeset(%User{}, %{}) conn |&gt; render(&quot;new.html&quot;, changeset: changeset) end def create(conn, %{&quot;user&quot; =&gt; user_params}) do changeset = %User{} |&gt; User.create_changeset(user_params) |&gt; Secret.put_session_secret() case Repo.insert(changeset) do {:ok, _user} -&gt; conn |&gt; redirect(to: &quot;/&quot;) {:error, changeset} -&gt; conn |&gt; render(&quot;new.html&quot;, changeset: changeset) end end end If we want less boilerplate we can use Entrance.User.create/1 and Entrance.User.create_changeset/0 that does all this setup for us: your_app/lib/your_app_web/controllers/user_controller.ex |$ mix entrance.gen.phx_user_controller defmodule YourAppWeb.UserController do use YourAppWeb, :controller def new(conn, _params) do conn |&gt; render(&quot;new.html&quot;, changeset: Entrance.User.create_changeset) end def create(conn, %{&quot;user&quot; =&gt; user_params}) do case Entrance.User.create(user_params) do {:ok, _user} -&gt; conn |&gt; redirect(to: &quot;/&quot;) {:error, changeset} -&gt; conn |&gt; render(&quot;new.html&quot;, changeset: changeset) end end end We can also create users based in another schemas (not only the default configured in Mix.Config): Entrance.User.create(Customer, customer_params) And get their create_changesets too... Entrance.User.create_changeset(Customer) Logging in users To login users we can use Entrance.auth and Entrance.Login.Session.login/2. your_app/lib/your_app_web/controllers/session_controller.ex |$ mix entrance.gen.phx_session_controller defmodule YourAppWeb.SessionController do use YourAppWeb, :controller import Entrance.Login.Session, only: [login: 2] def new(conn, _params) do render(conn, &quot;new.html&quot;) end def create(conn, %{&quot;session&quot; =&gt; %{&quot;email&quot; =&gt; email, &quot;password&quot; =&gt; password}}) do if user = Entrance.auth(email, password) do conn |&gt; login(user) # Sets :user_id and :session_secret on conn&#39;s session |&gt; put_flash(:notice, &quot;Successfully logged in&quot;) |&gt; redirect(to: &quot;/&quot;) else conn |&gt; put_flash(:error, &quot;No user found with the provided credentials&quot;) |&gt; render(&quot;new.html&quot;) end end end Entrance have some other functions that might fit well too, if you need... More fields matching the user schema Entrance.auth_by: Entrance.auth_by([email: email, admin: true], password) More fields matching the same value, Entrance.auth_one: Entrance.auth_one([:email, :nickname], my_nickname, password) More fields matching the same value, and more fields matching the user schema Entrance.auth_one_by: Entrance.auth_one_by({[:email, :nickname], my_nickname}, [admin: true], password) Note: In this README example, we did not create the :admin or :nickname fields in Accounts.User schema Read more about Entrance &quot;auth functions&quot; variations here. Requiring Authentication To require a user to be authenticated you can build a simple plug around Entrance.logged_in?/1. your_app/lib/your_app_web/plugs/require_login.ex |$ mix entrance.gen.phx_require_login defmodule YourAppWeb.Plugs.RequireLogin do import Plug.Conn def init(opts), do: opts def call(conn, _opts) do if Entrance.logged_in?(conn) do conn else conn |&gt; Phoenix.Controller.redirect(to: &quot;/session/new&quot;) |&gt; halt end end end An example in your_app/lib/your_app_web/router.ex: pipeline :protected do plug YourAppWeb.Plugs.RequireLogin end # ... scope &quot;/protected&quot;, YourAppWeb do pipe_through :browser pipe_through :protected get &quot;/&quot;, PageController, :protected end # ... Logging out users To logout users we can use Entrance.Login.Session.logout/1 your_app/lib/your_app_web/controllers/session_controller.ex |$ mix entrance.gen.phx_session_controller defmodule YourAppWeb.SessionController do use YourAppWeb, :controller import Entrance.Login.Session, only: [login: 2, logout: 1] # Import logout def new(conn, _params) do render(conn, &quot;new.html&quot;) end def create(conn, %{&quot;session&quot; =&gt; %{&quot;email&quot; =&gt; email, &quot;password&quot; =&gt; password}}) do if user = Entrance.auth(email, password) do conn |&gt; login(user) |&gt; put_flash(:notice, &quot;Successfully logged in&quot;) |&gt; redirect(to: &quot;/&quot;) else conn |&gt; put_flash(:error, &quot;No user found with the provided credentials&quot;) |&gt; render(&quot;new.html&quot;) end end # Add delete function to your sessions controller def delete(conn, _params) do conn |&gt; logout # Use logout function |&gt; put_flash(:notice, &quot;Successfully logged out&quot;) |&gt; redirect(to: &quot;/&quot;) end end Testing You can easily test routes that require authentication following the example below: your_app/test/your_app_web/controllers/page_controller_test.exs defmodule YourAppWeb.PageControllerTest do use YourAppWeb.ConnCase import Entrance.Login.Session, only: [login: 2] # Add this line # Setup an logged_in_conn setup do # Create your test user {:ok, user} = Entrance.User.create(%{email: &quot;test@test.com&quot;, password: &quot;test&quot;}) opts = Plug.Session.init( store: :cookie, key: &quot;test_key&quot;, encryption_salt: &quot;test_encryption_salt&quot;, signing_salt: &quot;test_signing_salt&quot;, log: false, encrypt: false ) logged_in_conn = build_conn() |&gt; Plug.Session.call(opts) |&gt; fetch_session() |&gt; login(user) %{logged_in_conn: logged_in_conn} end test &quot;GET /protected&quot;, %{logged_in_conn: logged_in_conn} do response = logged_in_conn |&gt; get(&quot;/protected&quot;) assert html_response(response, 200) # Yeah, it passes! end end Mix tasks We can generate all the modules above with: $ mix entrance.gen.phx_modules This generator will add the following files to lib/: a controller in lib/your_app_web/controllers/user_controller.ex a view in lib/your_app_web/views/user_view.ex a controller in lib/your_app_web/controllers/session_controller.ex a view in lib/your_app_web/views/session_view.ex a plug in lib/your_app_web/plugs/require_login.ex And also a test file for each of this files. We can set a different context if necessary: $ mix entrance.gen.phx_modules --context Accounts With &quot;--context Accounts&quot; it creates: a controller in lib/your_app_web/controllers/accounts/user_controller.ex a view in lib/your_app_web/views/accounts/user_view.ex a controller in lib/your_app_web/controllers/accounts/session_controller.ex a view in lib/your_app_web/views/accounts/session_view.ex a plug in lib/your_app_web/plugs/accounts/require_login.ex It&#39;s a nice start point for our app authentication."},{"ref":"readme.html#contribute","title":"Entrance - Contribute","type":"extras","doc":"Entrance is not only for me, but for the Elixir community. I&#39;m totally open to new ideas. Fork, open issues and feel free to contribute with no bureaucracy. We only need to keep some patterns to maintain an organization: branchs your_branch_name commits [your_branch_name] Your commit"},{"ref":"readme.html#credits","title":"Entrance - Credits","type":"extras","doc":"Entrance was built upon Doorman. Thanks to Blake Williams &amp; Ashley Foster. For the logo, thanks to Melissa Moreira."}]